###################################################
### chunk number 1: preliminaries
###################################################
#line 119 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
options(SweaveHooks= list(fig=function() par(mar=c(5.1, 4.1, 1.1, 2.1))),
        width = 75,
        digits = 7, # <-- here, keep R's default!
        prompt = "R> ",
        continue=" ")
Sys.setenv(LANGUAGE = "en")
if(.Platform$OS.type != "windows")
  Sys.setlocale("LC_MESSAGES","C")


###################################################
### chunk number 2: diagnose-lib
###################################################
#line 128 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
if(nzchar(Sys.getenv("R_MM_PKG_CHECKING"))) print( .libPaths() )


###################################################
### chunk number 3: exp-1
###################################################
#line 141 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
exp(1)


###################################################
### chunk number 4: exp-1-dig-17
###################################################
#line 146 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
print(exp(1), digits = 17)


###################################################
### chunk number 5: exp-1-mp
###################################################
#line 152 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
require("Rmpfr") # after having installed the package ...
(one <- mpfr(1, 120))
exp(one)


###################################################
### chunk number 6: factorial-1
###################################################
#line 164 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
ns <- 1:24 ; factorial(ns)


###################################################
### chunk number 7: factorial-full
###################################################
#line 169 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
noquote(sprintf("%-30.0f", factorial(24)))


###################################################
### chunk number 8: factorial-mpfr
###################################################
#line 175 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
ns <- mpfr(1:24, 120) ; factorial(ns)


###################################################
### chunk number 9: chooseM-ex-fake eval=FALSE
###################################################
## #line 180 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
## chooseMpfr.all(n = 80)


###################################################
### chunk number 10: chooseM-ex-do-hidden eval=FALSE
###################################################
## #line 182 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
## co <- capture.output(chooseMpfr.all(n = 80))
## writeLines(co[1:5]);cat(" ... \n ... \n")
## writeLines(co[13:16]);cat(" ... \n ... \n");writeLines(tail(co,2))
## ## Instead (above: eval=false): For now, still use the full:


###################################################
### chunk number 11: chooseM-run
###################################################
#line 187 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
#line 180 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw#from line#187#"
chooseMpfr.all(n = 80)
#line 188 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"


###################################################
### chunk number 12: ex1
###################################################
#line 232 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
(0:7) / 7  #  k/7,  for  k= 0..7  printed with R's default precision
options(digits= 16)
(0:7) / 7  #  in full  double precision accuracy
options(digits=  7) # back to default
str(.Machine[c("double.digits","double.eps", "double.neg.eps")], digits=10)
2^-(52:53)


###################################################
### chunk number 13: n-digs
###################################################
#line 245 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
53 * log10(2)


###################################################
### chunk number 14: ex1
###################################################
#line 256 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
x <- mpfr(0:7, 80)/7 # using 80 bits precision
x
7*x
7*x  - 0:7


###################################################
### chunk number 15: Const-names
###################################################
#line 269 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
formals(Const)$name


###################################################
### chunk number 16: Const-ex
###################################################
#line 277 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
Const("pi")
Const("log2")


###################################################
### chunk number 17: pi-1000
###################################################
#line 283 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
system.time(Pi <- Const("pi", 1000 *log2(10)))
Pi


###################################################
### chunk number 18: Math-group
###################################################
#line 307 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
getGroupMembers("Math")


###################################################
### chunk number 19: Matrix-ex
###################################################
#line 355 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
head(x <- mpfr(0:7, 64)/7) ; mx <-  x
dim(mx) <- c(4,2)


###################################################
### chunk number 20: crossprod
###################################################
#line 360 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
mx[ 1:3, ] + c(1,10,100)
crossprod(mx)


###################################################
### chunk number 21: apply-mat
###################################################
#line 365 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
apply(7 * mx, 2, sum)


###################################################
### chunk number 22: Ei-curve
###################################################
#line 382 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
curve(Ei,  0, 5, n=2001);  abline(h=0,v=0, lty=3)


###################################################
### chunk number 23: Li2-1
###################################################
#line 401 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
if(mpfrVersion() >= "2.4.0")  ## Li2() is not available in older MPFR versions
  all.equal(Li2(1), Const("pi", 128)^2/6, tol = 1e-30)


###################################################
### chunk number 24: Li2-curve
###################################################
#line 408 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
if(mpfrVersion() >= "2.4.0")
   curve(Li2, -2, 13,   n=2000); abline(h=0,v=0, lty=3)


###################################################
### chunk number 25: erf-curves
###################################################
#line 423 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
curve(erf, -3,3, col = "red", ylim = c(-1,2))
curve(erfc, add = TRUE, col = "blue")
abline(h=0, v=0, lty=3)
legend(-3,1, c("erf(x)", "erfc(x)"), col = c("red","blue"), lty=1)


###################################################
### chunk number 26: integrateR-dnorm
###################################################
#line 444 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
integrateR(dnorm,0,2000)
integrateR(dnorm,0,2000, rel.tol=1e-15)
integrateR(dnorm,0,2000, rel.tol=1e-15, verbose=TRUE)


###################################################
### chunk number 27: integ-exp-double
###################################################
#line 456 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
(Ie.d <- integrateR(exp,            0     , 1, rel.tol=1e-15, verbose=TRUE))


###################################################
### chunk number 28: integ-exp-mpfr
###################################################
#line 460 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
(Ie.m <- integrateR(exp, mpfr(0,200), 1, rel.tol=1e-25, verbose=TRUE))
(I.true <- exp(mpfr(1, 200)) - 1)
## with absolute errors
as.numeric(c(I.true - Ie.d$value,
             I.true - Ie.m$value))


###################################################
### chunk number 29: integ-poly-double
###################################################
#line 470 "d:/Rcompile/CRANpkg/local/2.12/Rmpfr/inst/doc/Rmpfr-pkg.Rnw"
if(require("polynom")) {
    x <- polynomial(0:1)
    p <- (x-2)^4 - 3*(x-3)^2
    Fp <- as.function(p)
    print(pI <- integral(p)) # formally
    print(Itrue <- predict(pI, 5) - predict(pI, 0)) ## == 20
} else {
    Fp <- function(x) (x-2)^4 - 3*(x-3)^2
    Itrue <- 20
}
(Id <- integrateR(Fp, 0,      5))
(Im <- integrateR(Fp, 0, mpfr(5, 256),
                  rel.tol = 1e-70, verbose=TRUE))
## and the numerical errors, are indeed of the expected size:
256 * log10(2) # - expect ~ 77 digit accuracy for mpfr(*., 256)
as.numeric(Itrue - c(Im$value, Id$value))


